#!/usr/bin/python2

import os, fcntl


LOG_PATH="/var/log/security-switch.log"
#LOG_PATH="./security-switch.log"

class LogManager:
	fd = None

	@classmethod
	def log(cls, message):
		logfd = cls.getfd()
		fcntl.lockf(logfd, fcntl.LOCK_EX)
		logfd.write(message)
		logfd.flush()
		fcntl.lockf(logfd, fcntl.LOCK_UN)

	@classmethod
	def debug(cls, message):
		cls.log("Debug: %s\n"%message)

	@classmethod
	def error(cls, message):
		cls.log("Error: %s\n"%message)

	@classmethod
	def getfd(cls):
		if not cls.fd:
			cls.fd = open(LOG_PATH, "w")
		return cls.fd

	@classmethod
	def close(cls):
		cls.fd.close()
		cls.fd = None

	@classmethod
	def __del__(cls):
		print "destruct logmanager"
		cls.close()


def log_debug(message):
	LogManager.debug(message)

def log_error(message):
	LogManager.error(message)
