# -*- coding:utf-8 -*-
#!/usr/bin/python2

from modules_desc import security_modules
from utils import print_err, check_package, check_ksymbol
from log import log_error, log_debug

class SecurityModule:
	status_desc={ "0": "关闭", "1": "启用" }
	def __init__(self, name):
		self.module_desc=security_modules[name]	
		self.name=security_modules[name]["name"]
		self.desc=security_modules[name]["desc"]

	def check_kernel(self):
		log_debug("检查内核符号表: '%s'\n"%self.module_desc["ksymbol"])
		result, error = check_ksymbol(self.module_desc["ksymbol"])
		if not result and error:
			log_error("获取内核配置信息时出错：%s\n"%error)
		
		return result

	def check_packages(self, modules):
		pkg_unmatched = []
		for item in self.module_desc["packages"]:
			log_debug("检查软件包 '%s' ...\n"%item["name"])
			if not check_package(item["name"], item["modified"]):
				pkg_unmatched.append(item["name"])
				
		if not len(pkg_unmatched):
			return (True, None)

		return (False, pkg_unmatched)

	@staticmethod
	def getstatus_desc(status_desc, status):
		status = str(status)
		if status_desc.has_key(status):
			return status_desc[status]
		return "未知"

	def check_system(self, next_state):
		return (True, None)

	def pre_enable(self):
		return (True, None)

	def pre_disable(self):
		return (True, None)

	def post_enable(self):
		return (True, None)

	def post_disable(self):
		return (True, None)

	def do_enable(self):
		return (True, None)

	def do_disable(self):
		return (True, None)
